<?
/*
Plugin Name: wp-ricoFlash
Plugin URI: http://www.joserico.com/blog/
Description: Este plugin te permite insertar flash en tus posts. S&oacute;lamente tienes que utilizar las etiquetas: [swf]ruta_hasta_el_flash.swf, ancho, alto, color_fondo, extras[/swf].
Version: 1.0
Author: Jos&eacute; Rico Mira 
Author URI: http://www.joserico.com/blog/
*/

define("wp_ricoFlash_version", "ricoFlash_version", true);
define("wp_ricoFlash_bgcolor", "ricoFlash_bgcolor", true);
define("wp_ricoFlash_wmode", "ricoFlash_wmode", true);
define("wp_ricoFlash_menu", "ricoFlash_menu", true);
define("wp_ricoFlash_quality", "ricoFlash_quality", true);
define("wp_ricoFlash_message", "ricoFlash_message", true);

define("wp_ricoFlash_version_default", "7", true);
define("wp_ricoFlash_bgcolor_default", "#FFFFFF", true);
define("wp_ricoFlash_wmode_default", "window", true);
define("wp_ricoFlash_menu_default", "false", true);
define("wp_ricoFlash_quality_default", "high", true);
define("wp_ricoFlash_message_default", "Esta pelcula requiere el flash player 7", true);

add_option(wp_ricoFlash_version, wp_ricoFlash_version_default, 'Version del Flash Player.');
add_option(wp_ricoFlash_bgcolor, wp_ricoFlash_bgcolor_default, 'Color de fondo del flash (desactivado)');
add_option(wp_ricoFlash_wmode, wp_ricoFlash_wmode_default, 'WMode del flash (desactivado)');
add_option(wp_ricoFlash_menu, wp_ricoFlash_menu_default, 'Opcin para activar el men del flash');
add_option(wp_ricoFlash_quality, wp_ricoFlash_quality_default, 'Calidad del flash por defecto');
add_option(wp_ricoFlash_message, wp_ricoFlash_message_default, 'Mensaje para el usuario sin plugin');

$idrnd = substr(md5(uniqid(rand(), true)),0,4);		// create unique id for divs
$flashcont = 0;        								// counter for files


//funciones
function wpricoFlashConfig() {
	// get config options into array var
    static $config;
    if ( empty($config) ) {
        $config['wp_ricoFlash_message'] = get_option(wp_ricoFlash_message);
        $config['wp_ricoFlash_wmode'] = get_option(wp_ricoFlash_wmode);
        $config['wp_ricoFlash_menu'] = get_option(wp_ricoFlash_menu);
        $config['wp_ricoFlash_quality'] = get_option(wp_ricoFlash_quality);
        $config['wp_ricoFlash_version'] = get_option(wp_ricoFlash_version);
        $config['wp_ricoFlash_bgcolor'] = get_option(wp_ricoFlash_bgcolor);
    }
    return $config;
}
function wpricoFlashParse($text) {
    return preg_replace_callback('|\[swf\](.+?),\s*(\d+)\s*,\s*(\d+)\s*(,(.+?))?\[/swf\]|i', 'wpricoFlashObject', $text);
}
function wpricoFlashObject($match) {
    global $idrnd, $flashcont;
	$swf_config = wpricoFlashConfig();
	$flashcont++;
	$writeswf = "\n";
    if (is_feed() || $doing_rss) {
		// for feed insert <object>
		
		$writeswf.= "<script type='text/javascript'>";
		$writeswf.= "AC_FL_RunContent( 'codebase','http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=7,0,19,0','width','".$match[2]."','height','".$match[3]."','src','".$match[1]."','quality','high','pluginspage','http://www.macromedia.com/go/getflashplayer','movie','".$match[1]."', 'FlashVars', '".$match[5]."' );";
		$writeswf.= "</script>";
		$writeswf.= "<noscript>";
		$writeswf.= "<object classid='clsid:D27CDB6E-AE6D-11cf-96B8-444553540000' codebase='http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=7,0,19,0' width='".$match[2]."' height='".$match[3]."'>";
		$writeswf.= "<param name='movie' value='".$match[1]."' />";
		$writeswf.= "<param name='quality' value='high' />";
		$writeswf.= "<embed src='".$match[1]."' quality='high' pluginspage='http://www.macromedia.com/go/getflashplayer' type='application/x-shockwave-flash' width='".$match[2]."' height='".$match[3]."'></embed>";
		$writeswf.= "</object>";
		$writeswf.= "</noscript>";
		
		
		/*$writeswf.= "<object type=\"application/x-shockwave-flash\" ";
		$writeswf.= "width=\"".$match[2]."\" height=\"".$match[3]."\">\n";
		$writeswf.= "<param name=\"movie\" value=\"".$match[1]."\" />\n";
		if ($match[4] != "") {
			$writeswf.= "<param name=\"flashvars\" value=\"".trim(substr($match[4],1))."\" />\n";
		}
		$writeswf.= "<embed src=\"".$match[1]."\" type=\"application/x-shockwave-flash\" ";
		$writeswf.= "width=\"".$match[2]."\" height=\"".$match[3]."\" ";
		if ($match[4] != "") {
			$writeswf.= "flashvars=\"".trim(substr($match[4],1))."\" ";
		}
		$writeswf.= ">\n";
		$writeswf.= "</object>\n";
		*/
		
	} else {
		$flash_cortado = ereg_replace(".swf", "", $match[1]);		
		$writeswf.= "<script type='text/javascript'>";
		$writeswf.= "AC_FL_RunContent( 'codebase','http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=7,0,19,0','width','".$match[2]."','height','".$match[3]."','src','".$flash_cortado."','quality','high','pluginspage','http://www.macromedia.com/go/getflashplayer','movie','".$flash_cortado."', 'FlashVars', '".$match[4]."' );";
		$writeswf.= "</script>";
		$writeswf.= "<noscript>";
		$writeswf.= "<object classid='clsid:D27CDB6E-AE6D-11cf-96B8-444553540000' codebase='http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=7,0,19,0' width='".$match[2]."' height='".$match[3]."'>";
		$writeswf.= "<param name='movie' value='".$match[1]."' />";
		$writeswf.= "<param name='quality' value='high' />";
		$writeswf.= "<embed src='".$match[1]."' quality='high' pluginspage='http://www.macromedia.com/go/getflashplayer' type='application/x-shockwave-flash' width='".$match[2]."' height='".$match[3]."'></embed>";
		$writeswf.= "</object>";
		$writeswf.= "</noscript>";
		
	}
	return $writeswf;
}
function wp_ricoFlashobject_echo($ricoFlashfile, $ricoFlashwidth, $ricoFlashheigth, $ricoFlashvars = "") {
    echo wpricoFlashObject( array( null, $ricoFlashfile, $ricoFlashwidth, $ricoFlashheigth, $ricoFlashvars) );
}

function wpricoFlashOptionsPage() {
	if (isset($_POST['wp_ricoFlash_update'])) {
		check_admin_referer();
		// Update version
		$swf_version = $_POST[wp_ricoFlash_version];
		if ($swf_version == '')
			$swf_version = wp_ricoFlash_version_default;
		update_option(wp_ricoFlash_version, $swf_version);
		// Update bgcolor
		$swf_bgcolor = $_POST[wp_ricoFlash_bgcolor];
		if ($swf_bgcolor == '')
			$swf_bgcolor = wp_ricoFlash_bgcolor_default;
		update_option(wp_ricoFlash_bgcolor, $swf_bgcolor);
		// Update wmode
		$swf_wmode = $_POST[wp_ricoFlash_wmode];
		update_option(wp_ricoFlash_wmode, $swf_wmode);
		// Update menu
		$swf_menu = $_POST[wp_ricoFlash_menu];
		update_option(wp_ricoFlash_menu, $swf_menu);
		// Update quality
		$swf_quality = $_POST[wp_ricoFlash_quality];
		update_option(wp_ricoFlash_quality, $swf_quality);
		// Update bgcolor
		$swf_message = $_POST[wp_ricoFlash_message];
		update_option(wp_ricoFlash_message, $swf_message);
		
		// echo message updated
		echo "<div class='updated'><p><strong>Las opciones se han actualizado con &eacute;xito</strong></p></div>";
	}
	?>
	<form method="post" action="options-general.php?page=wp-ricoFlash.php">
	<div class="wrap">
		<h2>Opciones para el Flash</h2>
		<fieldset class='options'>
			<table class="editform" cellspacing="2" cellpadding="5" width="100%">
				<tr>
					<th width="30%" valign="top" style="padding-top: 10px;">
						<label for="<?php echo wp_ricoFlash_version; ?>">Versi&oacute;n Flash Player:</label>
					</th>
					<td>
						<?php
						echo "<input type='text' size='16' maxlength='1' ";
						echo "name='".wp_ricoFlash_version."' ";
						echo "id='".wp_ricoFlash_version."' ";
						echo "value='".get_option(wp_ricoFlash_version)."' />\n";
						?>
						Inserta la versi&oacute;n del reproductor flash m&iacute;nima que debe estar instalda.
					</td>
				</tr>
				<tr>
					<th valign="top" style="padding-top: 10px;">
						<label for="<?php echo wp_ricoFlash_bgcolor; ?>">Color de fondo:</label>
					</th>
					<td>
						<?php
						echo "<input type='text' size='16' maxlength='7' ";
						echo "name='".wp_ricoFlash_bgcolor."' ";
						echo "id='".wp_ricoFlash_bgcolor."' ";
						echo "value='".get_option(wp_ricoFlash_bgcolor)."' />\n";
						?>
						Introduce un color hexadecimal para el fondo de la pel&iacute;cula flash.
					</td>
				</tr>
				<tr>
					<th valign="top" style="padding-top: 10px;">
						<label for="<?php echo wp_ricoFlash_wmode; ?>">Window Mode:</label>
					</th>
					<td>
						<?php
						echo "<select name='".wp_ricoFlash_wmode."' id='".wp_ricoFlash_wmode."'>\n";
	
						echo "<option value='window'";
						if(get_option(wp_ricoFlash_wmode) == "window")
							echo " selected='selected'";
						echo ">Window</option>\n";
						
						echo "<option value='opaque'";
						if(get_option(wp_ricoFlash_wmode) == "opaque")
							echo " selected='selected'";
						echo ">Opaque</option>\n";
						
						echo "<option value='transparent'";
						if(get_option(wp_ricoFlash_wmode) == "transparent")
							echo " selected='selected'";
						echo ">Transparent</option>\n";
						
						echo "</select>\n";
						?>
						Selecciona un fondo para tu flash, por defecto en '<strong>window</strong>'.
					</td>
				</tr>
				<tr>
					<th valign="top" style="padding-top: 10px;">
						<label for="<?php echo wp_ricoFlash_menu; ?>">Ver Menu:</label>
					</th>
					<td>
						<?php
						echo "<select name='".wp_ricoFlash_menu."' id='".wp_ricoFlash_menu."'>\n";
	
						echo "<option value='true'";
						if(get_option(wp_ricoFlash_menu) == "true")
							echo " selected='selected'";
						echo ">True</option>\n";
						
						echo "<option value='false'";
						if(get_option(wp_ricoFlash_menu) == "false")
							echo " selected='selected'";
						echo ">False</option>\n";
						
						echo "</select>\n";
						?>
						Selecciona una opci&oacute;n para el men&uacute; del flash show/hide.
					</td>
				</tr>
				<tr>
					<th valign="top" style="padding-top: 10px;">
						<label for="<?php echo wp_ricoFlash_bgcolor; ?>">Calidad del swf:</label>
					</th>
					<td>
						<?php
						echo "<select name='".wp_ricoFlash_quality."' id='".wp_ricoFlash_quality."'>\n";
	
						echo "<option value='low'";
						if(get_option(wp_ricoFlash_quality) == "low")
							echo " selected='selected'";
						echo ">Low</option>\n";
						
						echo "<option value='autolow'";
						if(get_option(wp_ricoFlash_quality) == "autolow")
							echo " selected='selected'";
						echo ">Autolow</option>\n";
						
						echo "<option value='autohigh'";
						if(get_option(wp_ricoFlash_quality) == "autohigh")
							echo " selected='selected'";
						echo ">autohigh</option>\n";
						
						echo "<option value='medium'";
						if(get_option(wp_ricoFlash_quality) == "medium")
							echo " selected='selected'";
						echo ">Medium</option>\n";
						
						echo "<option value='high'";
						if(get_option(wp_ricoFlash_quality) == "high")
							echo " selected='selected'";
						echo ">high</option>\n";
						
						echo "<option value='best'";
						if(get_option(wp_ricoFlash_quality) == "best")
							echo " selected='selected'";
						echo ">Best</option>\n";
						
						echo "</select>\n";
						?>
						Selecciona la calidad de la pel&iacute;cula flash, por defecto en <strong>hight</strong>.
					</td>
				</tr>
				<tr>
					<th width="30%" valign="top" style="padding-top: 10px;">
						<label for="<?php echo wp_ricoFlash_version; ?>">Mensaje error Flash:</label>
					</th>
					<td>
						<?php
						echo "<input type='text' size='60' ";
						echo "name='".wp_ricoFlash_message."' ";
						echo "id='".wp_ricoFlash_message."' ";
						echo "value='".get_option(wp_ricoFlash_message)."' />\n";
						?>
						<p style="margin: 5px 10px;">Introduce un mensaje por si no tiene el reproductor flash m&iacute;nimo.</p>
					</td>
				</tr>
				<tr>
					<td colspan="2">
					<p class="submit"><input type='submit' name='wp_ricoFlash_update' value='Update Options' /></p>
					</td>
				</tr>
				<tr>
					<th width="30%" valign="top" style="padding-top: 10px; text-align:left;" colspan="2">
						Informaci&oacute;n y soporte
					</th>
				</tr>
				<tr>
					<td colspan="2">
					Basado en el wp-swfObject de <a href="http://blog.unijimpe.net/wp-swfobject/">http://blog.unijimpe.net/wp-swfobject/</a>. Para m&aacute;s informaci&oacute;n visita <a href="http://www.joserico.com/blog/">http://www.joserico.com/blog/</a>
					</td>
				</tr>
			</table>
		</fieldset>
	</div>
	</form>	
	<?
}
function wpricoFlashAddMenu() {
	add_options_page('wp-ricoFlash Options', 'RicoFlash', 8, basename(__FILE__), 'wpricoFlashOptionsPage');
}
function wpricoFlashAddheader() {
	echo "<!-- wp-ricoFlash 1.0 por Jos&eacute; Rico (www.joserico.com) -->\n";
	echo "<script src=\"".get_settings('siteurl')."/wp-content/plugins/wp-ricoFlash/AC_RunActiveContent.js\" type=\"text/javascript\"></script>\n";
}

add_filter('the_content', 'wpricoFlashParse');
add_action('wp_head', 'wpricoFlashAddheader');
add_action('admin_menu', 'wpricoFlashAddMenu');

?>